#include <iostream>
#include <fstream>
#include <stdexcept>

//const int N = 10; //oscylatory
const int N = 8; //grawitacja

#include "Numeryka.h"
#include "Fizyka.h"

int main()
{
	double* y = new double[N];
	double* y_nast = new double[N];
	for (int i = 0; i < N; ++i)
	{
		y[i] = 0;
		y_nast[i] = 0;
	}

	y[6] = jednostkaOdleglosci; //m, y2;
	y[5] = 1.022E3; //m/s, vx2

	//modyfikacja prdkoci pocztkowych = przejcie do ukadu rodka masy
	static const double M = jednostkaMasy;
	static const double m = 0.0123*jednostkaMasy;
	static const double Mm = M + m;
	double Vsm_x = (M*y[1] + m*y[5]) / Mm;
	double Vsm_y = (M*y[3] + m*y[7]) / Mm;
	y[1] -= Vsm_x;
	y[5] -= Vsm_x;
	y[3] -= Vsm_y;
	y[7] -= Vsm_y;

	double Rsm_x = (M*y[0] + m*y[4]) / Mm;
	double Rsm_y = (M*y[2] + m*y[6]) / Mm;
	y[0] -= Rsm_x;
	y[4] -= Rsm_x;
	y[2] -= Rsm_y;
	y[6] -= Rsm_y;

	const double tmax = 365 * jednostkaCzasu; //rok
	//double h = 1E-10*jednostkaCzasu;
	double h = 1;

	std::ofstream plik_wy("wyniki.dat");
	plik_wy.precision(10);
	plik_wy.setf(std::ios::scientific);

	for (double t = 0; t < tmax; t += h)
	{
		//odeint_Euler<double>(N, rzut, y, t, h, y_nast);
		//odeint_MidPoint<double>(N, rzut, y, t, h, y_nast);
		//odeint_Euler<double>(N, oscylator_harmoniczny, y, t, h, y_nast);
		//odeint_MidPoint<double>(N, oscylator_harmoniczny, y, t, h, y_nast);
		//odeint_RK4<double>(N, oscylator_harmoniczny, y, t, h, y_nast);
		
		//odeint_MidPoint<double>(N, oscylatory_sprzezone, y, t, h, y_nast);
		//odeint_RK4<double>(N, oscylatory_sprzezone<double>, y, t, h, y_nast);
		//odeint_RK4F5<double>(N, oscylatory_sprzezone<double>, y, t, h, y_nast);

		odeint_RK4F5<double>(N, grawitacja<double>, y, t, h, y_nast);		
		//odeint_RK4<double>(N, grawitacja<double>, y, t, h, y_nast);

		//std::cout << "t=" << t << ", h=" << h << "\n";

		plik_wy << t << "\t" << h << "\t";
		for(int i=0;i<N;++i) plik_wy << y[i] << "\t";
		plik_wy << "\n";

		//ze rozwizanie
		//for (int i = 0; i < N; ++i) y[i] = y_nast[i];

		//dobre rozwizanie
		std::swap(y, y_nast);
	}

	delete[] y;
	delete[] y_nast;

	plik_wy.close();

	std::cout << "h=" << h << "\n";

	std::cout << "OK.";

	//system("pause");
}